import java.lang.*;
import java.io.*;
import java.util.*;
import java.sql.*;

class graphDay {
  menu_test parent;

  public graphDay(menu_test menu, String aQuery, String name, String fromDay, String toDay) {
    try {
      String	data;
      int	i;
      String url = 
	"jdbc:mijdbc://sandman.npac.syr.edu:7531/GIS";
      String query, condition;

      this.parent = menu;

      Integer from = new Integer(fromDay);
      Integer to = new Integer(toDay);

      if (from.intValue() > to.intValue() ) {
        System.out.println("Illegal day period input.");
        System.exit(0);
      }

      Class.forName( "mijdbc.MIDriver" );      

      Connection conn = 
	DriverManager.getConnection(url,"miadmin","");
      
      Statement stat = conn.createStatement();

      FileOutputStream s = new FileOutputStream(name + ".sva");
      DataOutput aDO = new DataOutputStream(s);

      data = "1"+"\n"+"\r";
      StringBuffer line = new StringBuffer(data);
      aDO.writeBytes(line.toString());
      data = "1.0"+"\n"+"\r";
      line = new StringBuffer(data);
      aDO.writeBytes(line.toString());

      i = from.intValue();
      System.out.println("From: " + from.toString() + " To: " + to.toString());
      for (; i <= to.intValue() ; i++) {

        condition = Integer.toString(i);

        query = aQuery + "'Mar " + condition + " 1998 00:00:00' and " +
                "'Mar " + condition + " 1998 23:59:59';";
        System.out.println("Query: " + query);
	parent.setMessage("Counting " + condition + " of March data.");
        ResultSet rs = stat.executeQuery(query);

        if ( rs.next() ) {
	  String s1 = rs.getString(1);
          data = Integer.toString(i)+" "+s1+"\n"+"\r";
          line = new StringBuffer(data);
	  System.out.println("Count from a query at "+condition+" is "+s1+".");
          aDO.writeBytes(line.toString());
        }
      }
      s.close();
      conn.close();
      Runtime.getRuntime().exec("java SV " + name + ".sva");
      parent.setMessage("Please see the visualized graph.");
    }
    catch ( Exception e ) {
      System.err.println("Exception: "+e);
      e.printStackTrace();
    }
  }
}