import java.awt.*;
import java.applet.Applet;

class menu_test extends Frame {
    headPanel tp;
    menuPanel mp;
    selectPanel sp;
    buttonPanel bp;
    String headQuery = "select count (RemoteHost) from Access_Logs where ";
    String condition;
    String timeCondition;
    String query;
    String title = "Default";
    String aDay;
    String aMonth = "Mar";
    String aYear = "1998";
    String fromDay = "8";
    String toDay = "14";

    static boolean isHourly = false;
    static boolean isDaily = false;
    static boolean isAll = false;

  public static void main(String argv[]) {
    menu_test win = new menu_test();

    win.setTitle("Menu Test");
    win.setSize(480,400);
    win.setResizable(false);
    win.setBackground(Color.white);
    win.show();
  }

  public menu_test() {
    
    tp = new headPanel();
    mp = new menuPanel(this);
    sp = new selectPanel();
    bp = new buttonPanel(this);

    setLayout(new GridLayout(4, 0, 0, 10));
    add(tp);
    add(mp);
    add(sp);
    add(bp);

    validate();
  }

  public boolean handleEvent(Event e) {
    if (e.id == Event.WINDOW_DESTROY) {
      System.exit(0);
    }
    return super.handleEvent(e);
  }

  public void changeArea(String area) {
    System.out.println("Change to "+area);
    ((CardLayout)sp.areaP.getLayout()).show(sp.areaP, area);
  }

  public void changeDate(String date) {
    System.out.println("Change to "+date);
    ((CardLayout)sp.dateP.getLayout()).show(sp.dateP, date);
  }

  public void setisHourly() {
    isHourly = true;
    isDaily = false;
  }

  public void setisDaily() {
    isDaily = true;
    isHourly = false;
  }

  public void setCondition(int sel, String input) {
    if ( sel == 0 ) {
      condition = null;
      timeCondition = null;
      isAll = false;
    }
    else if ( sel == 1 ) {
      if (condition != null) condition = input + condition;
      else condition = input;
    }
    else if ( sel == 2 ) {
      if (condition == null)
        System.out.println("Condition has only date information");
      else {
        if (isAll) {
	  condition = condition + "AccessDate between ";
        }
	else {
	  condition = condition + " and AccessDate between ";
	}
        timeCondition = input;
      }
    }
    else { System.out.println("Error: Illegal selection in setCondition."); }
  }

  public void getCondition() {
    String select;

    select = mp.spaceP.spaceG.getSelectedCheckbox().getLabel();
    if (select.equals("Site")) {
      setCondition(1, "RemoteHost = '" + sp.siteP.getCondition() + "'");
      title = "SiteGraph";
      System.out.println("Site is on");
    }
    else if (select.equals("Domain")) {
      String country;
      country = sp.domainP.getCondition();
      if (country.equals("All")) {
        isAll = true;
	setCondition(1, " ");
      }
      else {
        setCondition(1, "Country = '  " + sp.domainP.getCondition() + "'");
      }
      title = "CountryGraph";
      System.out.println("Domain is on");
    }
    else if (select.equals("Page")) {
      if (sp.pageP.IsPrefix()) {
        setCondition(1, "AccessPage like '" + sp.pageP.getCondition() + "%'");
      }
      else {
        setCondition(1, "AccessPage = '" + sp.pageP.getCondition() + "'");
      }
      title = "PageGraph";
      System.out.println("Page is on");
    }

    select = mp.timeP.timeG.getSelectedCheckbox().getLabel();
    if (select.equals("A Day Hourly")) {
      setisHourly();
      aDay = getDate(sp.aDate.getText());
      setCondition(2, aMonth + " " + aDay + " " + aYear);
      query = headQuery + condition + " ";
    }
    else if (select.equals("A Week Daily")) {
      setisDaily();
      fromDay = getDate(sp.fromDate.getText());
      toDay = getDate(sp.toDate.getText());
      setCondition(2, aMonth + " ");
      query = headQuery + condition;
    }

    System.out.println("Condition: \"" + condition + "\".");    
  }

  public String getDate(String day) {
    return day.trim();
  }

  public void execution() {
    getCondition();
    setMessage("Making a graph file");
    if (isHourly) {
      graphs aGraph = new graphs(this, query, timeCondition, "Hourly"+title);
    }
    else if (isDaily) {
      graphDay aGraph = new graphDay(this, query, "Daily"+title, fromDay, toDay);
    }
    setCondition(0, "");
  }

  public void setMessage(String aMessage) {
    tp.message.setText(aMessage);
  }
}

class headPanel extends Panel {
  TextField message;

  public headPanel() {
    System.out.println("HeadPanel");
    setBackground(Color.white);
    GridBagLayout gb = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setLayout(gb);

    c.fill = GridBagConstraints.BOTH;

    c.gridheight = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;   
    Panel tp = new Panel();
    tp.setFont(new Font("TimesRoman", Font.BOLD, 38));
    Label title = new Label("Statistics");
    tp.add(title);
    gb.setConstraints(tp, c);
    add(tp);

    c.gridheight = 1;
    Panel mp = new Panel(); 
    mp.setFont(new Font("Courier", Font.PLAIN, 12));
    message = new TextField("   Welcome to NPAC Statistics   ");
    message.setEditable(false);
    mp.add(message);
    gb.setConstraints(mp, c);
    add(mp);
  }
}

class menuPanel extends Panel {
  menu_test parent;
  spacePanel spaceP;
  timePanel timeP;

  public menuPanel(menu_test parent) {
    System.out.println("MenuPanel");
    this.parent = parent;
    setBackground(Color.white);
    setLayout(new GridLayout(0, 2, 40, 5));

    spaceP = new spacePanel(this);
    timeP = new timePanel(this);

    add(spaceP);
    add(timeP);
  }

  public Insets insets() {
    return new Insets(5, 80, 5, 80);
  }
}

class spacePanel extends Panel {
  menuPanel parent;
  CheckboxGroup spaceG;

  public spacePanel(menuPanel parent) {
    this.parent = parent;
    setBackground(Color.yellow);
    setLayout(new GridLayout(3,0,2,2));
    spaceG = new CheckboxGroup();
    add(new Checkbox("Site", spaceG, true));
    add(new Checkbox("Domain", spaceG, false));
    add(new Checkbox("Page", spaceG, false));
  }

  public boolean action(Event evt, Object arg) {

    if (evt.target instanceof Checkbox) {
      String select;
      select = spaceG.getSelectedCheckbox().getLabel();
      System.out.println(select + " selected.");
      this.parent.parent.changeArea(select);
    }
    return false;
  }
}

class timePanel extends Panel {
  menuPanel parent;
  CheckboxGroup timeG;

  public timePanel(menuPanel parent) {
    this.parent = parent;
    setBackground(Color.green);
    setLayout(new GridLayout(2,0,2,2));
    timeG = new CheckboxGroup();
    add(new Checkbox("A Day Hourly", timeG, true));
    add(new Checkbox("A Week Daily", timeG, false));
  }

  public boolean action(Event evt, Object arg) {
    if (evt.target instanceof Checkbox) {
      String select;
      select = timeG.getSelectedCheckbox().getLabel();
      System.out.println(select + " selected.");
      this.parent.parent.changeDate(select);
    }
    return false;
  }
}

class selectPanel extends Panel {
  Panel areaP;
  Panel dateP;

  sitePanel siteP;
  domainPanel domainP;
  pagePanel pageP;

  TextField aDate;
  TextField fromDate;
  TextField toDate;

  public selectPanel() {
    System.out.println("SelectPanel");
    setLayout(new GridLayout(2, 0));

    areaP = new Panel();
    areaP.setLayout(new CardLayout());

    siteP = new sitePanel(this);
    domainP = new domainPanel(this);
    pageP = new pagePanel(this);

    areaP.add("Site", siteP);
    areaP.add("Domain", domainP);
    areaP.add("Page", pageP);
    //((CardLayout)areaP.getLayout()).show(areaP, "site");

    dateP = new Panel();
    dateP.setLayout(new CardLayout());

    Panel twoP;
    twoP = new Panel();
    twoP.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 20));
    Label fromMonth;
    fromMonth = new Label("Mar");
    fromDate = new TextField(" 8");
    Label aSpace = new Label("     ");
    Label toMonth;
    toMonth = new Label("Mar ");
    toDate = new TextField("14");
    twoP.add(fromMonth);
    twoP.add(fromDate);
    twoP.add(aSpace);
    twoP.add(toMonth);
    twoP.add(toDate);

    Panel oneP;
    oneP = new Panel();
    oneP.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 20));
    Label aMonth;
    aMonth = new Label("Mar");
    aDate = new TextField(" 8");
    oneP.add(aMonth);
    oneP.add(aDate);

    dateP.add("A Day Hourly", oneP);
    dateP.add("A Week Daily", twoP);

    add(areaP);
    add(dateP);
  }
}

class sitePanel extends Panel {
  selectPanel parent;
  TextField site;

  public sitePanel(selectPanel target) {
    this.parent = target;
    setBackground(Color.white);
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 20));
    site = new TextField("scooter.pa-x.dec.com");
    add(site);
  }

  public String getCondition() {
    return site.getText();
  }
}

class domainPanel extends Panel {
  selectPanel parent;
  Choice domain;
  String country = "All";

  public domainPanel(selectPanel target) {
    this.parent = target;
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 20));
    domain = new Choice();
    domain.addItem("All");
    domain.addItem("US Educational");
    domain.addItem("US Commercial");
    domain.addItem("Network");
    domain.addItem("Canada");
    domain.addItem("United Kingdom");
    domain.addItem("Sweden");
    domain.addItem("Japan");
    add(domain);
  }

  public void setCountry(String newCountry) {
    country = newCountry;
  }

  public String getCondition() {
    return country;
  }

  public boolean action(Event e, Object arg) {
    if (e.target instanceof Choice) {
      setCountry((String)arg);
      return true;
    }
    return false;
  }
}

class pagePanel extends Panel {
  selectPanel parent;
  TextField page;
  Checkbox prefix;
  
  public pagePanel(selectPanel target) {
    this.parent = target;
    setLayout(new FlowLayout(FlowLayout.CENTER, 5, 20));
    page = new TextField("/textbook/kidsweb/");
    prefix = new Checkbox("Prefix");
    add(page);
    add(prefix);
  }

  public boolean IsPrefix() {
    return prefix.getState();
  }

  public String getCondition() {
    return page.getText();
  }
}

class buttonPanel extends Panel {
  menu_test parent;

  public buttonPanel(menu_test target) {
    System.out.println("ButtonPanel");
    this.parent = target;
    setBackground(Color.white);
    setLayout(new BorderLayout());
    add("Center", new Button("Visualize"));
  }

  public Insets insets() {
    return new Insets(25, 120, 25, 120);
  }

  public boolean action(Event evt, Object arg) {
    if (evt.target instanceof Button) {
      System.out.println((String)arg+" is pressed.");
      this.parent.execution();
    }
    return true;
  }
}